/*
 * Copyright (C) 2014 Alina Trifan and António Neves
 * mailto: alina.trifan@ua.pt -- an@ua.pt 
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "SocketState.h"

std::ostream& operator<<(std::ostream& out, const SocketState state) {
    out << "state[";

    switch (state) {
        case OPEN:
            out << "open";
            break;
        case CLOSED:
            out << "closed";
            break;
        case BOUNDED:
            out << "bounded";
            break;
        case CONNECTED:
            out << "connected";
            break;
        case LISTENING:
            out << "listening";
            break;
        default:
            out << "unknown state";
            break;
    }

    out << "]";

    return out;
}
