/*
 * Copyright (C) 2014 Alina Trifan and António Neves
 * mailto: alina.trifan@ua.pt -- an@ua.pt 
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "CameraOpenCV.h"

namespace uav{


int CameraOpenCV::readFrame(cv::Mat &image)
{
	capture >> image;

	//image = cv::imread("x.png");
	//cv::cvtColor(image, image, CV_BGR2RGB);

	return 0;
}

int CameraOpenCV::init(CameraSettings *camSettings)
{
	//capture = cv::VideoCapture(0);

	return 0;
}

int CameraOpenCV::initCamera(CameraSettings *camSettings)
{
	capture = cv::VideoCapture(0);

	return 0;

}

void CameraOpenCV::startCamera(CameraSettings *camSettings)
{

	std::cout<<"Method not supported" << std::endl;

}

void CameraOpenCV::stopCamera(CameraSettings *camSettings)
{

	std::cout<<"Method not supported!" << std::endl;

}

void CameraOpenCV::shutDownCamera()
{

	std::cout<<"Method not supported" <<std::endl;

}

void CameraOpenCV::getParameter(unsigned parameter, double *value)
{

	switch(parameter)
	{

	case UAV_FPS:

		*value = capture.get(CV_CAP_PROP_FRAME_WIDTH);
		break;

	default:
		fprintf(stderr, "Parameter not supported!");
		break;

	}
}

void CameraOpenCV::getParameterRanges(unsigned parameter, ParameterRange parameterRange)
{

	std::cout<<"Method not supported for this type of camera!"<<std::endl;


}

void CameraOpenCV::getParameters(CameraSettings *camSettings)
{
	double value;
	getParameter(UAV_FPS, &value);
}

void CameraOpenCV::getParametersRanges(ParameterRange* parameterRange)
{
	std::cout<<"Method not supported for this type of camera!" <<std::endl;

	parameterRange[UAV_EXPOSURE].min = 0; // FIXME: only for debug
	parameterRange[UAV_EXPOSURE].max = 100;
	parameterRange[UAV_GAIN].min = 0;
	parameterRange[UAV_GAIN].max = 100;
	parameterRange[UAV_WB].min = 0;
	parameterRange[UAV_WB].max = 100;

}

void CameraOpenCV::printParameter(unsigned parameter)
{

	double value;

	switch(parameter)
	{

	case UAV_FPS:

		value = capture.get(CV_CAP_PROP_FRAME_WIDTH);
		std::cout<<"FPS: "<<value << std::endl;
		break;

	default:
		std::cout <<"Parameter not supported!"<<std::endl;
		break;

	}
}

void CameraOpenCV::printParameters()
{
	printParameter(UAV_FPS);
}

void CameraOpenCV::setAutoMode(CameraSettings *camSettings)
{
	std::cout<<"Method not supported for this type of camera!"<<std::endl;
}

void CameraOpenCV::setManualMode(CameraSettings *camSettings)
{
	std::cout<<"Method not supported for this type of camera!"<<std::endl;
}

void CameraOpenCV::setParameter(unsigned parameter, unsigned value)
{

	switch(parameter)
	{

	case UAV_FPS:

		capture.set(CV_CAP_PROP_FRAME_WIDTH,value);
		break;

	default:
		std::cout<<"Parameter not supported!" << std::endl;
		break;

	}

}

void CameraOpenCV::setParameters(CameraSettings *camSettings)
{
	setParameter(UAV_FPS, camSettings->getCameraSetting(UAV_FPS));
}

}
