/*
 * Copyright (C) 2014 Alina Trifan and António Neves
 * mailto: alina.trifan@ua.pt -- an@ua.pt 
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef CAMERASETTINGSFACTORY_H_
#define CAMERASETTINGSFACTORY_H_

#include "CameraSettings.h"
#include "UAVision.h"
#include "Camera.h"

namespace uav{

/**
 * Class used as a factory for creating objects of the type
 * CameraSettings based on the camera type.
 */

class CameraSettingsFactory {
    public:
	/**
	 * Method for creating objects of the type CameraSettings
	 * based on the camera type.
	 */
      CameraSettings* Create(int camType);
};
}
#endif
