/*
 * Copyright (C) 2014 Alina Trifan and António Neves
 * mailto: alina.trifan@ua.pt -- an@ua.pt 
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef CAMERASETTINGSFIREWIRE_H_
#define CAMERASETTINGSFIREWIRE_H_

#include <libraw1394/raw1394.h>
#include <dc1394/dc1394.h>
#include <opencv2/opencv.hpp>
#include <iostream>
#include "UAVision.h"
#include "Camera.h"
#include "CameraSettings.h"

namespace uav{

class CameraSettingsFirewire:public CameraSettings{

public:

	unsigned int *buffer;


	/**
	 * Destructor.
	 */

	~CameraSettingsFirewire();
/*
		if(cameraWasUsed)
				{
					dc1394_camera_free(camera);
				}
*/


	/**
	 * Empty constructor that initializes all the members of the
	 * CameraSettingsEth class with dummy values.
	 */

	CameraSettingsFirewire();

	/**
	 * Method for printing the camera settings.
	 */
	void printCameraSettings();

	/**
	 * Method for retrieving just one camera setting.
	 * @param setting - camera setting to be retrieved.
	 */

	unsigned getCameraSetting(unsigned setting);

	/**
	 * Method for setting the value of one camera setting.
	 * @param setting - camera setting to be set.
	 * @param value - value of the camera setting to be set.
	 */
	void setCameraSetting(unsigned setting, unsigned value);

	/**
	 * Method for retrieving the size of an object of the type CamSettings.
	 */
	int getSize();

	unsigned int *ptr();

};
}
#endif
