/*
 * Copyright (C) 2014 Alina Trifan and António Neves
 * mailto: alina.trifan@ua.pt -- an@ua.pt 
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef RLE_H_
#define RLE_H_

#include <opencv2/opencv.hpp>
#include <iostream>
#include "UAVision.h"
#include "ScanLines.h"

namespace uav{
class RLE
{

public:

	std::vector<RLEInfo> rlData;
	ScanLines s;

	RLE(ScanLines &s_, unsigned colorBefore, unsigned colorOfInterest, unsigned colorAfter,
			unsigned threshColorBefore, unsigned threshColorOfInterest, unsigned threshColorAfter,
			unsigned searchWindow,  bool obstaclesCAMBADA = false);

	inline cv::Point getPointXYFromInteger(int idx)
	{
		cv::Point temp;
		temp.x = idx%s.image.cols;
		temp.y = idx/s.image.cols;

		return temp;
	}
	void draw(cv::Scalar colorBefore, cv::Scalar colorOfInterest, cv::Scalar colorAfter, cv::Mat &destination);
};
}
#endif
