/*
 * Copyright (C) 2014 Alina Trifan and António Neves
 * mailto: alina.trifan@ua.pt -- an@ua.pt 
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef LIBAUTOCALIB_H
#define LIBAUTOCALIB_H

#include "Config.h"
#include "UAVision.h"

using namespace uav;

void PaintIndexImage (cv::Mat &src, cv::Mat &dst, cv:: Mat &mask);

void PaintImage (cv::Mat &src, cv::Mat &dst, cv:: Mat &mask, ColorRange *cr);

void PaintPixelWithColor(cv::Mat &img, int pos, int color);

void drawHSVHistogram(cv::Mat &src, cv::Mat &hsvHist, cv::Mat &mask, unsigned int hMin,
  unsigned int hMax, int ncolor, std::vector<int> HArray, std::vector<int> SArray,
  std::vector<int> VArray, ColorRange *colorRange);

#endif

